## ros-indigo-fiducial-lib 0.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(fiducial_lib)

find_package(catkin REQUIRED COMPONENTS angles)

find_package(OpenCV REQUIRED)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES fiducials
  DEPENDS OpenCV
)

add_definitions(-g)
#add_definitions(-DMEMORY_LEAK_CHECK=1)

include_directories(include/fiducial_lib)
include_directories(${catkin_INCLUDE_DIRS})
include_directories(${OpenCV_INCLUDE_DIRS})

add_library(fiducials_base
  Bounding_Box.cpp CRC.cpp FEC.cpp File.cpp
  Memory.cpp String.cpp SVG.cpp)

add_library(fiducials_cv CV.cpp)
target_link_libraries(fiducials_cv fiducials_base ${OpenCV_LIBS})

add_library(fiducials Fiducials.cpp Arc.cpp Camera_Tag.cpp Map.cpp Tag.cpp)
target_link_libraries(fiducials fiducials_base fiducials_cv)

add_executable(Demo Demo.cpp)
target_link_libraries(Demo fiducials)
target_link_libraries(Demo m)

add_executable(Tags Tags.cpp)
target_link_libraries(Tags fiducials_base)
target_link_libraries(Tags m)

add_executable(Map_Test Map_Test.cpp)
target_link_libraries(Map_Test fiducials)
target_link_libraries(Map_Test m)

add_executable(Video_Capture Video_Capture.cpp)
target_link_libraries(Video_Capture fiducials_cv)
target_link_libraries(Video_Capture m)

install(TARGETS
  Demo Tags Map_Test Video_Capture
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(TARGETS fiducials_base fiducials_cv fiducials
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  PATTERN ".svn" EXCLUDE
)

=== Makefile ===
# Copyright (c) 2013 by Wayne C. Gramlich.  All rights reserved.

# ROS_ROOT needs to be a defined environment variable.
# Currently, mine is set to /opt/ros/groovy.
# See http://ros.org/ to see what it takes to get ROS installed.

ROS_INCLUDES := \
    -I$(ROS_ROOT)/include

ROS_LIBRARIES_DIRECTORY := \
    $(ROS_ROOT)/lib

POINT_GREY_INCLUDES := \
    -I/usr/include/flycapture \

# The following warning options tend to work for both C and C++:
MIXED_WARNING_OPTIONS := \
    -Wreturn-type \
    -Wno-missing-braces \
    -Wextra \
    -Wno-missing-field-initializers \
    -Wformat=2 \
    -Wswitch-default \
    -Wcast-align \
    -Wpointer-arith \
    -Winline \
    -Wundef \
    -Wshadow \
    -Wunreachable-code \
    -Wlogical-op \
    -Wfloat-equal \
    -Wstrict-aliasing=2 \
    -Wstrict-overflow=5 \

# The following warning options tend not to work for C++; they do work for C:
C_ONLY_WARNING_OPTIONS := \
     ${MIXED_WARNING_OPTIONS} \
    -Wbad-function-cast \
    -Wstrict-prototypes \
    -Wold-style-definition \
    -Werror \

# The following warning options should be turned on, but are causing problems:
C_NOT_WORKING_RIGHT := \
    -Wcast-qual \

# The following options are passed to the compiler.
# Warnings are done separately:
CC_OPTIONS := \
    -DPTGREY=1 \
    ${POINT_GREY_INCLUDES} \
    ${ROS_INCLUDES} \
    -L $(ROS_LIBRARIES_DIRECTORY) \
    -std=c11 \
    -g \
    -MMD \

# The following options are used sometimes:
OTHER_CC_OPTIONS := \
    -O3 \
    -pg \

# Use different warning options depending if C++ is encountered or not:
CC := gcc 
CC_MIXED :=  $(CC) ${CC_OPTIONS} ${MIXED_WARNING_OPTIONS}
CC_C_ONLY := $(CC) ${CC_OPTIONS} ${C_ONLY_WARNING_OPTIONS}

COMMON_O_FILES := \
    Bounding_Box.o \
    Character.o \
    CRC.o \
    Double.o \
    FEC.o \
    File.o \
    Float.o \
    Integer.o \
    List.o \
    Logical.o \
    Memory.o \
    String.o \
    SVG.o \
    Table.o \
    Unsigned.o \

DEMO_O_FILES := \
    Arc.o \
    Camera_Tag.o \
    CV.o \
    Demo.o \
    Fiducials.o \
    Location.o \
    Map.o \
    Tag.o \
    High_GUI2.o \

FLY_CAPTURE_O_FILES := \
    Arc.o \
    Camera_Tag.o \
    CV.o \
    FC2.o \
    Fiducials.o \
    Fly_Capture.o \
    High_GUI2.o \
    Location.o \
    Map.o \
    Tag.o \

FLYCAPTURE2TEST_O_FILES := \
    FC2.o \
    FlyCapture2Test.o \

MAP_TEST_O_FILES := \
    Arc.o \
    CV.o \
    Camera_Tag.o \
    Map.o \
    Map_Test.o \
    Tag.o \

TAGS_O_FILES := \
    Tags.o \

VIDEO_CAPTURE_O_FILES := \
    CV.o \
    FC2.o \
    High_GUI2.o \
    Video_Capture.o \

ALL_O_FILES := \
    ${COMMON_O_FILES} \
    ${DEMO_O_FILES} \
    ${FLYCAPTURE2TEST_O_FILES} \
    ${MAP_TEST_O_FILES} \
    ${TAGS_O_FILES} \
    ${VIDEO_CAPTURE_O_FILES} \

ALL_C_BACKUPS := ${ALL_O_FILES:%.o=%.c~}
ALL_D_FILES := ${ALL_O_FILES:%.o=%.d}
ALL_H_BACKUPS := ${ALL_O_FILES:%.o=%.h~}

REVIEW_FILE_BASES := \
    Arc \
    Camera_Tag \
    CV \
    Fiducials \
    List \
    Location \
    Map \
    Memory \
    String \
    Table \
    Tag

REVIEW_FILES := \
    ${REVIEW_FILE_BASES:%=%.c} \
    ${REVIEW_FILE_BASES:%=include/fiducials/%.h}

POINT_GREY_LIBRARIES := \
    -lflycapture-c \
    -lflycapture \

OPENCV_LIBRARIES := \
    -lopencv_core \
    -lopencv_imgproc \
    -lopencv_calib3d \
    -lopencv_highgui \
    -lm \

PROGRAMS := \
    Demo \
    Fly_Capture \
    FlyCapture2Test \
    Map_Test \
    Tags \
    Video_Capture \

all: ${PROGRAMS}

# Program linking:

Tags: ${COMMON_O_FILES} ${TAGS_O_FILES}
	${CC_C_ONLY} -o $@ ${TAGS_O_FILES} \
	  ${COMMON_O_FILES} -lm

Demo: ${COMMON_O_FILES} ${DEMO_O_FILES}
	${CC_C_ONLY} -o $@ ${DEMO_O_FILES} \
	  ${COMMON_O_FILES} ${OPENCV_LIBRARIES} -lm

Fly_Capture: ${COMMON_O_FILES} ${FLY_CAPTURE_O_FILES}
	${CC_MIXED} -o $@ ${FLY_CAPTURE_O_FILES} \
	  ${COMMON_O_FILES} ${OPENCV_LIBRARIES} ${POINT_GREY_LIBRARIES} -lm

FlyCapture2Test: ${FLYCAPTURE2TEST_O_FILES}
	${CC_MIXED} -o $@ ${FLYCAPTURE2TEST_O_FILES} \
	  ${COMMON_O_FILES} ${POINT_GREY_LIBRARIES}

Map_Test: ${COMMON_O_FILES} ${MAP_TEST_O_FILES}
	${CC_C_ONLY} -o $@ ${MAP_TEST_O_FILES} \
	  ${COMMON_O_FILES} ${OPENCV_LIBRARIES} -lm

Video_Capture: ${COMMON_O_FILES} ${VIDEO_CAPTURE_O_FILES}
	${CC_MIXED} -o $@ ${VIDEO_CAPTURE_O_FILES} \
	  ${COMMON_O_FILES} ${OPENCV_LIBRARIES} ${POINT_GREY_LIBRARIES} -lm

review.pdf: ${REVIEW_FILES}
	rm -rf /tmp/review /tmp/numbered
	mkdir -p /tmp/review /tmp/numbered
	cp ${REVIEW_FILES} /tmp/review
	(cd /tmp/review ; \
	    for i in *.[ch] ; do \
		echo $$i; \
		cat -n $$i > ../numbered/$$i ; \
	    done)
	(cd /tmp/numbered ; enscript *.h *.c -p - | ps2pdf - review.pdf)
	cp /tmp/numbered/review.pdf $@
	rm -rf /tmp/review /tmp/numbered

# Individual C file compilation:

FlyCapture2Test.o: FlyCapture2Test.c
	${CC_MIXED} -o $@ -c $<

FC2.o: FC2.c
	${CC_MIXED} -o $@ -c $<

Video_Capture.o: Video_Capture.c
	${CC_MIXED} -o $@ -c $<

Fly_Capture.o: Fly_Capture.c
	${CC_MIXED} -o $@ -c $<

clean:
	rm -f ${ALL_C_BACKUPS}
	rm -f ${ALL_D_FILES}
	rm -f ${ALL_H_BACKUPS}
	rm -f ${ALL_O_FILES}
	rm -f ${PROGRAMS}
	rm -f Makefile~ Tags.ezc~

%.o: %.c
	${CC_C_ONLY} -c -o $@ $<


# Used with gcc -MMD option to force automagic dependency checking:
-include ${ALL_D_FILES}

=== debian/changelog ===
ros-indigo-fiducial-lib (0.0.2-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Wayne Gramlich <wayne@gramlich.net>  Wed, 23 Nov 2016 02:38:44 -0000

=== debian/control ===
Source: ros-indigo-fiducial-lib
Section: misc
Priority: extra
Maintainer: Wayne Gramlich <wayne@gramlich.net>
Build-Depends: debhelper (>= 9.0.0), libopencv-dev, ros-indigo-angles, ros-indigo-catkin
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-fiducial-lib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopencv-dev, ros-indigo-angles
Description: The fiducials package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-fiducial-lib//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
